function symbols = a16psk(bits)

N = length(bits);
vec = logical(reshape(bits,4,N/4));
d_array = signal_constellation('16PSK');

greycode = [[0 0 0 0];
            [0 0 0 1];
            [0 0 1 1];
            [0 0 1 0];
            [0 1 1 0];
            [0 1 1 1];
            [0 1 0 1];
            [0 1 0 0];
            [1 1 0 0];
            [1 1 0 1];
            [1 1 1 1];
            [1 1 1 0];
            [1 0 1 0];
            [1 0 1 1];
            [1 0 0 1];
            [1 0 0 0]];
greycode = logical(greycode);
         
for k = 1 : 16
   matched = (vec(1,:)==greycode(k,1))&(vec(2,:)==greycode(k,2))&(vec(3,:)==greycode(k,3))&(vec(4,:)==greycode(k,4));
   symbols(matched) = d_array(k);
end;