function BR_sequence = invqpsk(CR_qpsk)
% BR_sequence = invqpsk(CR_qpsk)

PS_qpskLength = length(CR_qpsk);
PS_length = PS_qpskLength * 2;

CR_rotated = CR_qpsk*exp(j*pi/4);
BR_sequence = zeros(1,PS_length);

% for k = 1:PS_qpskLength
%    if imag(CR_rotated(k)) >= 0
%       BR_sequence(2*k-1) = 0;
%    else
%       BR_sequence(2*k-1) = 1;
%    end;
%    if real(CR_rotated(k)) >= 0
%       BR_sequence(2*k) = 0;
%    else
%       BR_sequence(2*k) = 1;
%    end;
% end;

% See if the incoming sequence is < or > 0.  If it's < 0, then it's true, it's a 1.
% Otherwise, it's a 0.  This nifty idea is done to follow the convention of Gray-encoded QPSK.
BR_sequence(1:2:length(BR_sequence)) = (imag(CR_rotated) < 0);
BR_sequence(2:2:length(BR_sequence)) = (real(CR_rotated) < 0);
