function RR_rcosf = rcosf(RR_freq, FS_rolloff, RS_period)
% RR_rcosf = rcosf(RR_freq, FS_rolloff, RS_period)

RS_index = 1;
for RS_freq = RR_freq
   if (abs(RS_freq) <= ((1-FS_rolloff)/(2*RS_period)))
      RR_rcosf(RS_index) = RS_period;
   elseif (abs(RS_freq) <= ((1+FS_rolloff)/(2*RS_period)))
      RR_rcosf(RS_index) = RS_period/2*(1+cos(pi*RS_period/FS_rolloff*(abs(RS_freq)-(1-FS_rolloff)/2/RS_period)));
   else
      RR_rcosf(RS_index) = 0;
   end;
   RS_index = RS_index+1;
end;